
PLUGIN_NAME = "模版路径管理" #定义插件的名字

# 注册信息
ex = SketchupExtension.new(PLUGIN_NAME,'open_path.rb')
ex.version = '1.2'
ex.description = '用于打开插件安装目录、SketchUp和LayOut相关模版'
ex.copyright ='www.yooox.net'
ex.creator = '优象Yooox'
Sketchup.register_extension(ex, true)

# 打开插件目录
def open_pl
  if RUBY_PLATFORM =~ /darwin/
    plugindir = Sketchup.find_support_file("Plugins")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = Sketchup.find_support_file("Plugins")
    UI.openURL(plugindir)
  end
end

#打开SketchUp我的模版路径
def open_mysketchup
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("~/Library/Application Support/SketchUp 20#{sketchup_version}/SketchUp/Templates")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "#{ENV['APPDATA']}/SketchUp/SketchUp 20#{sketchup_version}/SketchUp/Templates"
    # 构建本地文件 URL
    file_url = "file:///#{URI.escape(plugindir)}"
    # 打开本地文件 URL
    UI.openURL(file_url)
  end
end

#打开LayOut我的模版路径
def open_mylayout
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("~/Library/Application Support/SketchUp 20#{sketchup_version}/LayOut/Templates/")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "#{ENV['APPDATA']}/SketchUp/SketchUp 20#{sketchup_version}/LayOut/Templates"
    # 构建本地文件 URL
    file_url = "file:///#{URI.escape(plugindir)}"
    # 打开本地文件 URL
    UI.openURL(file_url)
  end
end

#打开LayOut默认模版路径
def open_default_layout
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("/Applications/SketchUp 20#{sketchup_version}/LayOut.app/Contents/Resources/zh_CN.lproj/Templates/Paper")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "C:/ProgramData/SketchUp/SketchUp 20#{sketchup_version}/Layout/zh-cn/Templates/Paper"
    # 构建本地文件 URL
    file_url = "file:///#{URI.escape(plugindir)}"
    # 打开本地文件 URL
    UI.openURL(file_url)
  end
end

#打开剪贴薄的保存路径
def open_my_scrapbooks
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("~/Library/Application Support/SketchUp 20#{sketchup_version}/LayOut/Scrapbooks/")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "C:/ProgramData/SketchUp/SketchUp 20#{sketchup_version}/LayOut/zh-CN/Scrapbooks"
     # 构建本地文件 URL
     file_url = "file:///#{URI.escape(plugindir)}"
     # 打开本地文件 URL
     UI.openURL(file_url)
  end
end

#打开隐藏的剪贴薄
def open_hide_scrapbooks
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("/Applications/SketchUp 20#{sketchup_version}/LayOut.app/Contents/Resources/en.lproj/Scrapbooks")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "C:/ProgramData/SketchUp/SketchUp 20#{sketchup_version}/LayOut/scrapbooks"
    UI.openURL(plugindir)
  end
end

#打开隐藏的系统隐藏的LayOut模版
def open_hide_layout
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  if RUBY_PLATFORM =~ /darwin/
    plugindir = File.expand_path("/Applications/SketchUp 20#{sketchup_version}/LayOut.app/Contents/Resources/en.lproj/Templates")
    system("open", plugindir)
  else RUBY_PLATFORM =~ /win64/
    plugindir = "C:/ProgramData/SketchUp/SketchUp 20#{sketchup_version}/LayOut/templates"
    UI.openURL(plugindir)
  end
end

#打开SketchUp崩溃恢复文件路径
def open_automatic_backup
  sketchup_version = Sketchup.version.to_i#获取SketchUp版本
  username = ENV['USERNAME'] #获取win系统当前用户的用户名
  if RUBY_PLATFORM =~ /darwin/
    UI.messagebox("Mac系统没有SketchUp崩溃恢复文件路径!")
  else RUBY_PLATFORM =~ /win64/

    sketchup_version = Sketchup.version.to_i#获取SketchUp版本
    username = ENV['USERNAME'] #获取win系统当前用户的用户名
    plugindir = "C:/Users/#{username}/AppData/Local/SketchUp/SketchUp 20#{sketchup_version}/SketchUp/working/SKETCHUP/RecoveredFiles"
    UI.openURL(plugindir)
  end
end

# 创建命令
cmd_open_pl = UI::Command.new("打开插件目录") { open_pl }
cmd_open_mysketchup = UI::Command.new("打开SketchUp我的模版路径") { open_mysketchup }
cmd_open_mylayout = UI::Command.new("打开LayOut我的模版路径") { open_mylayout }
cmd_open_default_layout = UI::Command.new("打开LayOut默认模版路径") { open_default_layout }
cmd_open_my_scrapbooks = UI::Command.new("打开剪贴薄的保存路径") { open_my_scrapbooks }
cmd_open_hide_scrapbooks = UI::Command.new("打开隐藏的剪贴薄") { open_hide_scrapbooks }
cmd_open_hide_layout = UI::Command.new("打开隐藏的系统隐藏的LayOut模版") { open_hide_layout }
cmd_open_automatic_backup = UI::Command.new("打开SketchUp崩溃恢复文件路径") { open_automatic_backup }


# 将命令添加到扩展菜单中
menu = UI.menu("Plugins")

# 创建一级菜单项
submenu = menu.add_submenu(PLUGIN_NAME)

# 添加二级菜单项
submenu.add_item("打开SketchUp插件目录") { open_pl }
submenu.add_item("打开SketchUp我的模版路径") { open_mysketchup}
submenu.add_item("打开SketchUp崩溃恢复文件路径") { open_automatic_backup }
submenu.add_item("打开LayOut我的模版路径") { open_mylayout }
submenu.add_item("打开LayOut默认模版路径") { open_default_layout }
submenu.add_item("打开LayOut隐藏模版路径") { open_hide_layout }
submenu.add_item("打开LayOut剪贴薄路径") { open_my_scrapbooks }
submenu.add_item("打开LayOut隐藏剪贴薄路径") { open_hide_scrapbooks }


